<?php 
namespace Teknisa\MAN\Services;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class CodigoExternoClienteService {
    	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function codigosCadastrados($P_CDCLIENTE, $P_NRORG){
		$params = array(
			':P_CDCLIENTE'         => $P_CDCLIENTE,
			':P_NRORG'             => $P_NRORG
		); 
		return $this->entityManager->getConnection()->fetchAll(self::CODIGO_EXTERNO_CLIENTE_CONTROLLER, $params);
	}
	
	public function saveCodigoExterno($params){
		$pesquisaCodigos = $this->validateSave($params);
		if(count($pesquisaCodigos)==0){
			$codigos = $this->entityManager->getConnection()->executeQuery(self::CODIGO_EXTERNO_CLIENTE_SAVE, $params);
		}else{
			throw new \Exception("Os parâmetros passados já existem para este cliente.", 1);
		}

	}
	
	public function deleteCodigoExterno($params){
		$codigos = $this->entityManager->getConnection()->executeQuery(self::CODIGO_EXTERNO_CLIENTE_DELETE, $params);
		return $codigos;
	}
	
	public function editCodigoExterno($params){
		$pesquisaCodigos = $this->validateSave($params);
		if(count($pesquisaCodigos)==0){
			$codigos = $this->entityManager->getConnection()->executeQuery(self::CODIGO_EXTERNO_CLIENTE_UPDATE, $params);
			return $codigos;
		}else{
			throw new \Exception("Os parâmetros passados já existem para este cliente.", 1);
		}
	}
	
	public function validateSave($params){
		$codigos = $this->entityManager->getConnection()->fetchAll(self::CODIGO_EXTERNO_CLIENTE_UNICO, $params);
		return $codigos;
	}
	
	
    const CODIGO_EXTERNO_CLIENTE_CONTROLLER = 
    "SELECT  CE.CDCLIENTE, CE.NRORG, CE.CDFILIAL, CE.CDEXCLIENTEIMP, F.NMFILIAL
	    FROM CODEXTCLIENTE CE 
	    LEFT JOIN FILIAL F 
	    ON CE.CDFILIAL = F.CDFILIAL
	    WHERE (CE.CDCLIENTE = :P_CDCLIENTE) 
	    AND (CE.NRORG = :P_NRORG)
	    ORDER BY CE.CDFILIAL" ;
        
    const CODIGO_EXTERNO_CLIENTE_SAVE =
    "INSERT INTO CODEXTCLIENTE
		(CDFILIAL, CDCLIENTE, CDEXCLIENTEIMP)
		values
		(:CDFILIAL, :CDCLIENTE, :CDEXCLIENTEIMP)" ;
		
	const CODIGO_EXTERNO_CLIENTE_DELETE =
	"DELETE FROM CODEXTCLIENTE
		WHERE
		  CDFILIAL       = :CDFILIAL and
		  CDCLIENTE      = :CDCLIENTE and
		  CDEXCLIENTEIMP = :CDEXCLIENTEIMP" ;
		  
	const CODIGO_EXTERNO_CLIENTE_UPDATE =
    "UPDATE CODEXTCLIENTE
		SET CDFILIAL = :CDFILIAL,
		CDEXCLIENTEIMP = :CDEXCLIENTEIMP
		WHERE CDCLIENTE = :CDCLIENTE
		AND CDFILIAL = :OLD_CDFILIAL
		AND CDEXCLIENTEIMP = :OLD_CDEXCLIENTEIMP
		AND NRORG = :NRORG" ;
		
	const CODIGO_EXTERNO_CLIENTE_UNICO =
	"SELECT  CE.CDCLIENTE, CE.CDFILIAL, CE.CDEXCLIENTEIMP
	    FROM CODEXTCLIENTE CE 
	    WHERE (CE.CDCLIENTE = :CDCLIENTE) 
	    AND (CE.CDFILIAL = :CDFILIAL)
	    AND (CE.CDEXCLIENTEIMP = :CDEXCLIENTEIMP)";

}